# How to Contribute

We'd love to get patches from you!

## Getting Started

This is a small guide on how to get started contributing to `XCMetrics` itself. A more in-depth guide on how to integrate it with your infrastructure is available [here](/docs/integration.md).

If you're specifically interested in contributing to the core of the tool, feel free to pick an [issue](https://github.com/spotify/XCMetrics/issues) and or mention `@spotify/foundation` for help.

## Building the Project

XCMetrics uses the Swift Package Manager to manage its dependencies and project. After cloning the repo, you can open the project from Xcode by opening the file `Package.swift`.

## Workflow

We follow the [GitHub Flow Workflow](https://guides.github.com/introduction/flow/)

1.  Fork the project
1.  Check out the `main` branch
1.  Create a feature branch
1.  Write code and tests for your change
1.  From your branch, make a pull request against `https://github.com/spotify/XCMetrics/main`
1.  Work with repo maintainers to get your change reviewed
1.  Wait for your change to be pulled into `https://github.com/spotify/XCMetrics/main`
1.  Delete your feature branch

## Testing

To run all tests, either run `swift test` from the command line or execute the tests via the project in Xcode.

## Style

### TODO: mention SwiftLint and SwiftFormat when integrated


## Documentation

The [docs](/docs/) directory contains all available documentation.

We also welcome improvements to the project documentation or to the existing docs. Please file an [issue](https://github.com/spotify/XCMetrics/issues/new).

# License

By contributing your code, you agree to license your contribution under the terms of the [LICENSE](LICENSE.md)]

# Code of Conduct

Read our [Code of Conduct](CODE_OF_CONDUCT.md) for the project.
